
#if !defined(AFX_BASETRACKERDLG_H__E51B32CD_F3F3_4A27_8A65_DD65711B46B9__INCLUDED_)
#define AFX_BASETRACKERDLG_H__E51B32CD_F3F3_4A27_8A65_DD65711B46B9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Project.h"
#include "OPF.h"
#include "UPF.h"
#include "RPF.h"

#define OptimizedPF 0
#define UnscentedPF 2
#define RegularizedPF 1

#define Yes 1
#define No 0

/////////////////////////////////////////////////////////////////////////////
// CBaseTrackerDlg dialog

/** @addtogroup mfc_group */
/* @{ */
class CBaseTrackerDlg : public CDialog
{
// Construction
public:
	CBaseTrackerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBaseTrackerDlg)
	enum { IDD = IDD_BASE_TRACKER_DIALOG };
	int		m_init_appearance_frame;
	int		m_set_state_frame;
	int		m_opf_nsamples;
	int	    m_method;
	int		m_mcstep;
	int		m_opti;
	int 	m_neff;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBaseTrackerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	Project project;
	OPF opf;
	UPF upf;
	RPF rpf;

	// Generated message map functions
	//{{AFX_MSG(CBaseTrackerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLoadKinematics();
	afx_msg void OnLoadAvi();
	afx_msg void OnSetThresholds();
	afx_msg void OnInitAppearance();
	afx_msg void OnSetState();
	afx_msg void OnTrack();
	afx_msg void OnSaveProject();
	virtual void OnOK();
	afx_msg void OnLoadProject();
	afx_msg void OnLoadDynamics();
	afx_msg void OnOptimizedPF();
	afx_msg void OnSavetracker();
	afx_msg void OnOpfBatch();
	afx_msg void OnMethodTrack();
	afx_msg void OnMethodBatch();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/* @} */

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASETRACKERDLG_H__E51B32CD_F3F3_4A27_8A65_DD65711B46B9__INCLUDED_)
