// InitEdges.cpp : implementation file
//

#include "stdafx.h"
#include "BaseTracker.h"
#include "InitEdges.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// InitEdges dialog


InitEdges::InitEdges(EdgeThresholdSetter &ets, CWnd* pParent /*=NULL*/)
    : CDialog(InitEdges::IDD, pParent), ets(ets)
{
	//{{AFX_DATA_INIT(InitEdges)
	m_low_thresh = 0;
	m_high_thresh = 0;
	//}}AFX_DATA_INIT

    ets.getThresholds(initLowThresh, initHighThresh);
}


void InitEdges::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(InitEdges)
	DDX_Text(pDX, IDC_EDIT1, m_low_thresh);
	DDX_Text(pDX, IDC_EDIT2, m_high_thresh);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(InitEdges, CDialog)
	//{{AFX_MSG_MAP(InitEdges)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InitEdges message handlers

void InitEdges::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void InitEdges::OnButton1() 
{
    UpdateData(TRUE);
    ets.setThresholds(m_low_thresh, m_high_thresh);
}

void InitEdges::OnCancel() 
{
    ets.setThresholds(initLowThresh, initHighThresh);
    ets.hide();
	CDialog::OnCancel();
}

BOOL InitEdges::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    m_low_thresh = initLowThresh;
    m_high_thresh = initHighThresh;
    UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
