#ifndef AVI_VIEWER_INCLUDED
#define AVI_VIEWER_INCLUDED

#include "cv.h"
#include "highgui.h"

/** @defgroup util_group Utilities */
/* @{ */
/**
    Allows for extracting frames from an AVI file.
    This serves as a wrapper for some OpenCV function
    calls.  Theoretically, I believe it should be able
    to open any AVI file for which you have the codec
    installed.  However, I've only been able to get it
    to work with uncompressed files.
 */
class AVIViewer {
public:
    AVIViewer();
    AVIViewer(const char * fname);
    ~AVIViewer();
    bool open(const char * fname);
    /**
        @return true if a file is currently open
     */
    bool isOpen() { return seqOpen; }
    /** 
        @return number of frames in the AVI file
     */
    int getLength() { return seqLength; }
    IplImage * getFrame(int frame);
    IplImage * getGrayFrame(int frame);

private:
    CvCapture *aviFile;
    bool seqOpen;
    int seqLength;
};
/* @} */

#endif // !def AVI_VIEWER_INCLUDED