#ifndef CONST_VEL_DYNAMICS_INCLUDED
#define CONST_VEL_DYNAMICS_INCLUDED

#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

#include "Dynamics.h"
#include "Vector.h"

/** @addtogroup dyn_group */
/* @{ */
/** Constant velocity dynamic model */
class ConstVelDynamics : public Dynamics {
private:
    /** Hidden state estimate */
    Vector x;
    /** Last state observation */
    Vector lastx;
    /** Estimated velocity */
    Vector vel;

    vector<Vector> history;
    
    enum {NUM_INIT_STATES = 2};

public:

//	ConstVelDynamics() {};
	
//	ConstVelDynamics(ConstVelDynamics &dyn);
	
	void copyStates(Dynamics* dyn_old);
	void copyStates(ConstVelDynamics* dyn_old);

	void setState(Vector &ys);

    int getNInitStates();
    void estimateX0(vector<Vector> &ys);
    
    Vector observe();
    Vector predict();
    void correct(Vector y);
    void back();
   
    void readFromFile(ifstream &fin);
};
/* @} */


#endif // !def CONST_VEL_DYNAMICS_INCLUDED