#ifndef IOFUN_INCLUDED
#define IOFUN_INCLUDED

#include <iostream>
#include <fstream>
using namespace std;

#define COMMENT_CHAR '%'

/** @addtogroup util_group */
/* @{ */
/**
    Contains some static utility functions for reading input from
    text files that may contain comment lines.
    Note that this class does not ever need to be instantiated.
 */
class IOFun {
public:
    static void readTokenWithComments(ifstream &fin, char *token, 
                                      int maxTokenLen, 
                                      const char *delims = " \t\n");
    static double readDoubleWithComments(ifstream &fin);
	static int readIntWithComments(ifstream &fin);
	static void readStringWithComments(ifstream &fin, char *buf, int n);
};
/* @} */

#endif // !def IOFUN_INCLUDED
