#include "cv.h"
#include "ImgFun.h"

/**
   Creates a new IPL image with the origin at the bottom left
    @param size width and height of image to create
    @param depth color depth of image to create
    @param channels number of channels in new image
    @return pointer to a new image
 */
IplImage * ImgFun::newImage(CvSize size, int depth, int channels) {
    IplImage *img = cvCreateImage(size, depth, channels);
   	img->origin = IPL_ORIGIN_BL;
    return img;
}