#ifndef MATH_FUN_INCLUDED
#define MATH_FUN_INCLUDED

#include "cv.h"
#include "Vector.h"
#include "Matrix.h"

/** @addtogroup util_group */
/* @{ */
/**
    Contains some static utility functions for various math stuff.
    This class should never need to be instantiated.
 */
class MathFun {
public:
    static double dist(const CvPoint &p1, const CvPoint &p2);
    static int round(double d);
    static void matVecMul(const Matrix &m, const Vector &v, Vector &vout);
    static void timesTranspose(const Matrix &Mt, Matrix &MtM);
};
/* @} */

#endif // !def MATH_FUN_INCLUDED
