#ifndef PATCH_APPEARANCE_MODEL_INCLUDED
#define PATCH_APPEARANCE_MODEL_INCLUDED

#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

#include "cv.h"
#include "AppearanceModel.h"
#include "KinematicTree.h"
#include "Matrix.h"
#include "ModelPoint.h"
#include "Vector.h"


/** @addtogroup app_group */
/* @{ */
/**
    THIS CLASS IS NOT COMPLETE! An appearance model that uses pixel feature.
 */
class PatchAppearanceModel : public AppearanceModel {
private:
    int nLinks, nPts;
    vector<ModelPoint> *patchPts;

    enum {STRIDE = 2};

    //void derivative(int x, int y, int val, double &dDdx, double &dDdy);
    bool inBounds(int x, int y);

    IplImage *frameImg;
    IplImage *dxImg, *dyImg;
    float *imgData;
    float *dxData, *dyData;
    int imgDataStep;
    int dxDataStep, dyDataStep;
    CvSize imgSize;

	/** True if model has been initialized */
    bool didInit;

public:
    PatchAppearanceModel();
    ~PatchAppearanceModel();
	bool initialized();
	void initialize(int n, IplImage **linkImgs, 
                    CvPoint *origins, KinematicTree *kt);
    
    void setImage(IplImage *img);
    Matrix * getJacobianT(KinematicTree *kt, IplImage *img = NULL);
    Matrix * getHessian(KinematicTree *kt, IplImage *img = NULL);
    void addJacobianWeights(Matrix &JtJ);
    double getScore(KinematicTree *kt, IplImage *img = NULL);
    Vector * getResidual(KinematicTree *kt, IplImage *img = NULL);
    
    void draw(IplImage *img, KinematicTree *kt, int red = 255, int green = 255,
              int blue = 255);
    void drawDerivative(IplImage *img, KinematicTree *kt, CvScalar color);
    void drawJacobian(IplImage *img, KinematicTree *kt, int stateIdx, CvScalar color);

    void writeToFile(ofstream &fout);
    void readFromFile(ifstream &fin);
};
/* @} */

#endif // !def PATCH_APPEARANCE_MODEL_INCLUDED
