#include <cstring>

#include "TrackerException.h"

/**
    Constructor.
    @param msg message associated with this exception
 */
TrackerException::TrackerException(char *msg) throw() {
    this->msg = new char[strlen(msg) + 1];
    strcpy(this->msg, msg);
}

/**
    Copy constructor
    @param te a TrackerException
 */
TrackerException::TrackerException(const TrackerException &te) {
    this->msg = new char[strlen(te.msg) + 1];
    strcpy(this->msg, te.msg);
}

/**
    Destructor.
 */
TrackerException::~TrackerException() {
    delete [] msg;
}

/**
    Returns a string describing the exception.
    @return a string describing the exception
 */
const char * TrackerException::what() const {
    return msg;
}
