#ifndef TRACKER_EXCEPTION_INCLUDED
#define TRACKER_EXCEPTION_INCLUDED

#include <exception>
using namespace std;

/** @addtogroup util_group */
/* @{ */
/**
    A not-very-specialized exception class.
    I think the only place this is currently used is in
    SPMLink::readFromFile().
    @see SPMLink::readFromFile
 */
class TrackerException : public exception {
private:
    /** Message associated with the exception */
    char *msg;
public:
    TrackerException(char *msg);
    TrackerException(const TrackerException &te);
    ~TrackerException();
    const char * what() const;
};
/* @} */

#endif // !def TRACKER_EXCEPTION_INCLUDED
