#ifndef EDGE_THRESHOLD_SETTER_INCLUDED
#define EDGE_THRESHOLD_SETTER_INCLUDED

#include "cv.h"

#define ETS_WINDOW_NAME ("ets_window")

/** @addtogroup bridge_group */
/* @{ */
/** 
    Displays output of Canny edge detector on an image
    for different threshold values.
 */
class EdgeThresholdSetter {
private:
    /** aperture size for Canny edge detector */
    enum {APERTURE_SIZE = 5};

    /** Low and high thresholds for Canny edge detector */
    int lowThresh, highThresh;

    /** The original image; should be a single-channel image */
    IplImage *origImg;
    
    /** Output of edge detector on origImg */
    IplImage *edgeImg;

public:
    EdgeThresholdSetter(IplImage *img, int lowThresh, int highThresh);
    ~EdgeThresholdSetter();
    void setThresholds(int lowThresh, int highThresh);
    void getThresholds(int &lowThresh, int &highThresh);
    void display();
    void hide();
};
/* @} */

#endif // !def EDGE_THRESHOLD_SETTER_INCLUDED