#ifndef PATCH_PIXEL_GRABBER_INCLUDED
#define PATCH_PIXEL_GRABBER_INCLUDED

#include <vector>
using namespace std;

#include "cv.h"
#include "highgui.h"

#include "KinematicTree.h"
#include "PatchAppearanceModel.h"

#define PPG_WINDOW_NAME ("ppg_window")

/** @addtogroup bridge_group */
/* @{ */
/** THIS CLASS IS NOT COMPLETE OR TESTED */
class PatchPixelGrabber {
private:
    static PatchPixelGrabber *thePPG;

    KinematicTree *kt;
    PatchAppearanceModel *pam;
    IplImage *origImg, *patchImg, *displayImg;
    unsigned char *patchData; 
    int patchStep; 
    CvSize patchSize;
    vector<CvPoint> controlPts;
    CvPoint origin;
    int mode;

    // Used in manipulating control points
    int draggedIdx;
    bool dragging;

    // Various drawing constants
    CvScalar BOX_COLOR, CP_COLOR, BOUNDARY_COLOR;
    enum {CP_RADIUS = 5};       // Radius of control pts

    // Scale factor of enlarged images
    enum {SCALE = 8};

    PatchPixelGrabber();
    PatchPixelGrabber(const PatchPixelGrabber &ppg);
    PatchPixelGrabber & operator=(const PatchPixelGrabber &ppg);
    ~PatchPixelGrabber();
    void display();

public:
    static PatchPixelGrabber * getInstance();
    void initialize(KinematicTree *kt, PatchAppearanceModel *pam,
                    IplImage *img);
    void reset();

    void getData(IplImage **linkImgs, CvPoint *origins);
    void hide();

    void mode0Mouse(int event, int x, int y, int flags);
}; 
/* @} */

// Mouse callback functions
void PPGMode0MouseCallback(int event, int x, int y, int flags, void* param);

#endif // !def PATCH_PIXEL_GRABBER_INCLUDED
